%this is the derivative of the continuation value

function w_b = w_b(b,z)
global sigma gamma z_H z_L A u up v vp w

%think about the initial guess

%c0 = b+z; %pretty bad guess, plus it is used all over again, could/should be improved
%c0 = b + z^((1+gamma)/(gamma+sigma)); %this is true for b = 0

if sigma == gamma
    c = (b + (b^2 + 4*z^((gamma+1)/gamma))^.5)/2;
else
    c0 = b+z; %pretty bad guess, plus it is used all over again, could/should be improved
    %c0 = b + .9*z^((1+gamma)/(gamma+sigma)); %this is true for b = 0
    %c0 = (b + (b^2 + 4*z^((gamma+1)/gamma))^.5)/2;
    options = optimset('display', 'off', 'tolfun', 10^(-10), 'maxfunevals', 1000000, 'maxiter', 1000000); 
    c=fsolve(@(c) up(c) - vp((c-b)/z)/z, c0, options);
end
w_b = up(c);