%this is the continuation value for the 'dynastic' model

function wdyn = wdyn(b)
global sigma gamma u up v vp Z2 phi phi1 phi2 R
z = Z2;
extra = (R*phi1)^(1/sigma)/R;
bmat = b*ones(1, length(z));
zmat = (z*ones(1, length(b)))';

if sigma == gamma
c = (bmat+phi2/R + ((bmat+phi2/R).^2 + 4*(1+extra)/phi^(1/gamma)*zmat.^((gamma+1)/gamma)).^.5)/(2*(1+extra));
else
display 'this only works for equal sigma = gamma buddy!'
end

wdyn = [u(c) - phi*v((c-bmat)./zmat); up(c)]; %first is the value, second is the derivative wrt b